---
image: registry.rebrainme.com/devops_users_repos/604/rebrainshop/terraform_runner:1.0.0

variables:
  TF_ROOT: ${CI_PROJECT_DIR}/deployments
  TF_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/development

cache:
  key: development
  paths:
    - ${TF_ROOT}/.terraform

before_script:
  - mkdir -p ~/.ssh
  - chmod 700 ~/.ssh
  - eval "$(ssh-agent -s)"
  - echo "$SSH_PRIVATE_KEY" | tr -d '\r' > ~/.ssh/id_rsa
  - chmod 600 ~/.ssh/id_rsa
  - ssh-add ~/.ssh/id_rsa
  - ssh-keyscan -t rsa gitlab.rebrainme.com >> ~/.ssh/known_hosts
  - chmod 644 ~/.ssh/known_hosts
  - cd ${TF_ROOT}

stages:
  - test
  - build
  - deploy
  - destroy

init:
  stage: test
  script:
    - gitlab-terraform init

validate:
  stage: test
  script:
    - gitlab-terraform validate

plan:
  stage: test
  needs: ["init", "validate"]
  script:
    - gitlab-terraform plan
    - gitlab-terraform plan-json
  artifacts:
    name: plan
    paths:
      - ${TF_ROOT}/plan.cache
    reports:
      terraform: ${TF_ROOT}/plan.json

apply:
  stage: build
  environment:
    name: development
  script:
    - gitlab-terraform apply
  dependencies:
    - plan
  artifacts:
    name: ansible_inv
    paths:
      - ${TF_ROOT}/ansible/inventory
  when: manual
  only:
    - main

deploy:
  image: registry.rebrainme.com/devops_users_repos/604/rebrainshop/ansible_runner:1.0.0
  stage: deploy
  environment:
    name: development
  script:
    - cd ${TF_ROOT}
    - /usr/bin/ansible-galaxy install -r ansible/requirements.yml -p ./ansible/roles --force
    - /usr/bin/ansible-playbook -i ansible/inventory ansible/site.yml
  dependencies:
    - apply
  when: manual
  only:
    - main

destroy:
  stage: destroy
  script:
    - gitlab-terraform destroy
  only:
    - main
  when: manual
  environment:
    name: development
    action: stop
...